# $Header:   //ARCHIVE/Archive_NLS/scripts/LoadClassIcons.ksv   1.1.1.1   Jun 21 2001 16:18:12   BRENT  $

# LoadClassIcons.ksh

# Script to load the class icons that are stored in the database from BMP files

Usage()
{
  print "USAGE:"
  print "  LoadClassIcons.ksh options... "
  print "  The options are:"
  print "    -U<user>         User name for the database login"
  print "    -P<password>     Password for the database login"
  print "    -S<server>       Database server"
  print "    -t<type>         Icon type. Current supported values are:"
  print "                     LARGE         - Large icon (45x45)" 
  print "                     LARGE_DELETED - Large deleted icon (45x45)"
  print "                     SMALL         - Small icon (23x23)" 
  print "                     SMALL_DELETED - Small deleted icon (23x23)"
  print ""
  print "Replaces the currently loaded  icon definitions with the bitmaps"
  print "in the current directory."
}


while getopts U:S:P:t: c; do
  case $c in
  U)  user_opt="-U$OPTARG";;
  P)  password_opt="-P$OPTARG";;
  S)  server_opt="-S$OPTARG";;
  t)  subtype="$OPTARG";;
  *)  Usage; exit;;
  esac
done

case "$subtype" in
  "LARGE")          colprefix=Large;;
  "LARGE_DELETED")  colprefix=LargeDeleted;;
  "SMALL")          colprefix=Small;;
  "SMALL_DELETED")  colprefix=SmallDeleted;;
  *)                Usage>&2; exit 1;;
esac

for cid in $(echo *.bmp | sed 's/.bmp//g' | tr '[a-z]' '[A-Z]'); do
  # Make sure the class has a BLOB for its static icon fields
  isql -n $user_opt $password_opt $server_opt -dObject <<- END
    if not exists (select * from BLOB_C where name = '$cid' and _Type = 'BMP' and _SubType = '$subtype')
      exec asisp_createBLOB '$cid', @Type='BMP', @SubType='$subtype'
    update BLOB_C set _Data = 0x0 where name = '$cid' and _Type = 'BMP' and _SubType = '$subtype'
    declare @cname varchar(24)
    select @cname = cname from obj_class where cid = '$cid'
    if @@rowcount = 1
      exec("update " + @cname + "_S set _${colprefix}IconName = convert(varchar(9), id) " + 
           "from BLOB_C where name = '$cid' and _Type = 'BMP' and _SubType = '$subtype'"
      )
END
  # Copy image into BLOB
  textcopy $user_opt $password_opt $server_opt -DObject -TBLOB_C -C_Data -W"where name = '$cid' and _Type = 'BMP' and _SubType = '$subtype'" -F$cid.bmp -I
done
