# $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/Scripts/imPopulateExclusionTable.ksv   1.4   Jun 19 2001 12:02:22   lin  $
# $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/Scripts/imPopulateExclusionTable.ksv  $
# $Revision:   1.4  $
# $Date:   Jun 19 2001 12:02:22  $
# $Author:   lin  $
#!/bin/sh
#set -x
#

localhost="$(print "$COMPUTERNAME" | awk '{print toupper($0);}')"

INSTALLDIR=$(regfind -p "HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0" -n "InstallDirectory" 2>nul: | grep InstallDirectory | sed 's/[ ]*InstallDirectory = //' | sed 's?\\?/?g' | sed 's/\/$//g') 

if [ ! -d "$INSTALLDIR" ]; then
  print >&2 "Invalid installation directory: $INSTALLDIR"
  print >&2 "Tivoli Business Systems Manager is not installed on this system"
  exit 1
fi

eval `regdmp "HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0\Settings\DB" | awk '/Server/ {printf("db_server=%s\n",$3);} /User/ {printf("db_user=%s\n",$3);} /Password/ {printf("db_password=%s\n",$3);}'`

if [ -z $db_server ] || [ -z $db_user ] || [ -z $db_password ]; then
  print >&2 "TBSM SQL Server is not set up on this system"
  exit 1
fi

db_server=$(echo $db_server | awk '{print toupper($0);}')

if [ "$db_server" != "$localhost" ]; then
  print >&2 "Please run $0 on TBSM SQL Server $db_server"
  exit 1
fi

usage   ()
{
  print ''
  print 'Usage: '$0' [options...]'
  print ''
  print '  -S<db_server>           Specifies server name where database resides.  Default=['$db_server'].'
  print '  -U<db_user>             Specifies database user name.  Default=['$db_user'].'
  print '  -P<db_password>         Specifies password for database user.  Default=['$db_password'].'
  print '  -E                      Use trusted database connection. Use this instead of -U<username> and -P<password>'
  print ''
  print ''
}

while getopts "U:S:P:Eh?" c; do
  case $c in
  U)  db_user=$OPTARG;;
  S)  db_server=$(echo $OPTARG | awk '{print toupper($0);}');;
  P)  db_password=$OPTARG;;
  E)  bTrusted=1;;
  h)  usage; exit 1;;
  \?) usage; exit 1;;
  *)  print >&2 Error with option $OPTOPT; usage; exit 1;;
  esac
done

#
if [ "$bTrusted" -eq 1 ]; then
  #SQLCMD="tbsmsql -S$db_server -E -n -w3000 "
  SQLCMD="osql -h-1 -S$db_server -E -n -w3000 "
else
  #SQLCMD="tbsmsql -S$db_server -U$db_user -P$db_password -n -w3000 "
  SQLCMD="osql -h-1 -S$db_server -U$db_user -P$db_password -n -w3000 "
fi

# now that we are on the right host

TBSMLogDir=$(regfind -p "HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0\Settings\Log" -n "Directory" 2>nul: | grep Directory | sed 's/[ ]*Directory = //' | sed 's?\\?/?g' | sed 's/:/\$/g' | awk -F"\$" '{OFS="$"; print toupper($1), $2}')

if [ ! -z $TBSMLogDir ]; then
  sql_cmd="
    SET NOCOUNT ON
    IF NOT EXISTS (SELECT * FROM imExclusionPattern WHERE path='$TBSMLogDir')
      INSERT INTO imExclusionPattern VALUES (N'%', N'FS', N'$TBSMLogDir', '%', '%', 1)
  "
  $SQLCMD -d'Object' -Q"$sql_cmd"

fi

INSTALLDIR=$(echo $INSTALLDIR | sed 's/:/\$/')
sql_cmd="
  SET NOCOUNT ON
  IF NOT EXISTS (SELECT * FROM imExclusionPattern WHERE path='$INSTALLDIR/Data/Queues')
      INSERT INTO imExclusionPattern VALUES (N'%', N'FS', N'$INSTALLDIR/Data/Queues', '%', '%', 1)
  "
$SQLCMD -d'Object' -Q"$sql_cmd"

#
