-- $Header:   //Archive/Archive_NLS/DB/sql/DEFECT_76770.sqv   1.0   Jun 11 2001 11:51:52   Blaine  
--
-- DEFECT_76770.sql
--
-- Module Description
--   Fixed to TSD Closure.
--
USE Object
GO

---------------------------------------------------------------------------------------------------
-- DEFECT_76770.sql
-- $Archive:   //Archive/Archive_NLS/DB/sql/DEFECT_76770.sqv  
-- $Revision:   1.0  
-- $Date:   Jun 11 2001 11:51:52  
-- $Author:   Blaine  

PRINT 'Updating stored procedure  _TSDCloseRequest'
GO

PRINT 'Dropping stored procedure  _TSDCloseRequest'
DROP PROC _TSDCloseRequest
GO

PRINT 'Recreating stored procedure  _TSDCloseRequest'
GO

/*
'Closes a TSD Problem Ticket'
 */
CREATE PROCEDURE _TSDCloseRequest
	@cid ClassID,
	@id ObjID,
	@APIHandle INT,
	@ProblemID NVARCHAR(20),
	@User NVARCHAR(100),
	@System NVARCHAR(100) = NULL,
	@Component NVARCHAR(100) = NULL,
	@Item NVARCHAR(100) = NULL,
	@Module NVARCHAR(100) = NULL,
	@Severity INT = NULL,
	@ProblemCode NVARCHAR(100) = NULL,
	@Description NVARCHAR(255) = NULL,
	@ProblemType NVARCHAR(100) = NULL,
	@Solution NVARCHAR(255) = NULL,
	@ErrorInfo INT OUTPUT
AS


	-- Override @ProblemCode value passed in and always set it to Closed.
	Set @ProblemCode = 'CLOSED'

	EXEC master..xp_TSDCloseRequest @APIHandle, @ProblemID, @User, @System, @Component, @Item, @Module, @Severity, @ProblemCode, @Description, @ProblemType, @Solution, @ErrorInfo OUTPUT
GO

PRINT 'Stored Procedure  _TSDCloseRequest updated.'
GO