-- $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/DEFECT_76840_20010531.sqv   1.0   Jun 01 2001 10:50:34   lin  $
--
-- DEFECT_76840_20010531.sql
--
-- Module Description
--   Backing out BasicSchemaVersion and SchemaVersion change tracking data.
--     The above two changes in object should not be tracked.
--
USE Object
GO

-----------------------------------------------------------------------------
-- Backing out BasicSchemaVersion and SchemaVersion change tracking data 
PRINT 'Backing out rows only have BasicSchemaVersion and SchemaVersion changes ...'
GO

-- $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/DEFECT_76840_20010531.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 01 2001 10:50:34  $
-- $Author:   lin  $
-- Backing out rows only have BasicSchemaVersion and SchemaVersion changes   
DELETE FROM imObjectList 
WHERE name IN (
  SELECT o1.name
  FROM imObjectList AS o1
  WHERE EXISTS (
    SELECT * FROM imObjectList AS o2
    WHERE o2.snapshotver = o1.snapshotver - 1
      AND o2.host = o1.host 
      AND o2.name = o1.name
      AND o2.path = o1.path
      AND o2.objectType = o1.objectType 
      AND o2.checksum = o1.checksum
      AND o2.blockcount = o2.blockcount
  )
)
