-- $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/DEFECT_77687_20010618.sqv   1.1   Jun 19 2001 11:25:46   lin  $
--
-- DEFECT_77687_20010618.sql
--
-- Module Description
--  Modification to allow NULL host names on Patch inserts.
--
--
USE Object
GO

-----------------------------------------------------------------------------
-- Update the existing host to NULL for those confirmed flag set to 0
PRINT 'Set host to NULL if confirmed is 0 ...'
GO

-- $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/DB/SQL/DEFECT_77687_20010618.sqv  $
-- $Revision:   1.1  $
-- $Date:   Jun 19 2001 11:25:46  $
-- $Author:   lin  $

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'imObjectList' AND type = 'U')
BEGIN
  UPDATE imObjectList SET host=NULL 
  WHERE confirmed = 0
    OR (snapshotver = 1 
      AND EXISTS (
        SELECT * FROM imSnapshotHistory 
          WHERE version = 1 AND state = 'Started' AND date = '2001-05-22 15:35:34.000'
      )
    )
END
GO

-----------------------------------------------------------------------------
-- Update state from Complete to Completed
IF EXISTS (SELECT * FROM sysobjects WHERE name = 'imSnapshotHistory' AND type = 'U')
BEGIN
  UPDATE imSnapshotHistory SET state = 'Completed'
  WHERE state = 'Complete'
  UPDATE imSnapshotHistory SET build = NULL
  WHERE build = ''
END
GO


