# $Header:   //ARCHIVE/Archive_NLS/db/sql/PostProcessSNMPCreateProc.ksv   1.2   May 23 2001 12:20:24   BRENT  $
# SID: %I%
# Last Modified: %E% %U%
#
# Post-processing for SNMP object creation stored procedures produced by dbgen

awk 'BEGIN {
  snmp_keywords["IPHostName"]=1;
  snmp_keywords["OID"]=1;
  snmp_keywords["SNMPsysObjectID"]=1;
  snmp_keywords["SNMPsyscontact"]=1;
  snmp_keywords["SNMPsysdescr"]=1;
  snmp_keywords["SNMPsyslocation"]=1;
  snmp_keywords["Vendor"]=1;
}
# Uncomment for diagnostic comments in output
#{
#  printf("/* in_param_list=%d is_snmp=%d in_proc_body=%d already_done=%d */  ", in_param_list, is_snmp, in_proc_body, already_done);#DBG
#}
/^CREATE PROCEDURE asisp_create/ {
  is_snmp=0;
  in_param_list=1;
  already_done=0;
  in_proc_body=0;
  # extract cid
  proc_name=$3;
  cid=proc_name;
  sub("asisp_create", "", cid);
}
in_param_list && $1=="@SNMPAgent" {
  already_done=1;
}
in_param_list && $1=="@SNMPsysObjectID" {
  is_snmp=1;
#  printf("-- is_snmp=1\n"); #DBG
}
!already_done && in_param_list && is_snmp && $1=="@Desc" {
  printf("  @SNMPAgent                     NVARCHAR(10) = \"\",\n");
}
!already_done && in_param_list && ($1=="AS"||$1=="as") {
  in_proc_body=1;
  in_param_list=0;
}
!already_done && in_proc_body && $1~/^[_@]/ {
  column=$1;
  sub("[_@]", "", column);
  sub("[,]", "", column);
  if (snmp_keywords[column] == 1)
    next;
}
!already_done && in_proc_body && ($1=="GO"||$1=="go") {
}
!already_done && in_proc_body && is_snmp && $0 ~ /[Ii][Nn][Ss][Ee][Rr][Tt] [Pp][Aa][Rr][Ee][Nn][Tt] [Ll][Ii][Nn][Kk]/ {
  # Output special-case SNMP code before link insert
  printf("  -- If @OID was left at default value of 0 then we invent a unique OID outside of\n");
  printf("  -- valid range of oids\n");
  printf("  IF @OID = 0\n");
  printf("    SELECT @OID = ISNULL(MAX(_oid)+1,1000000000)\n");
  printf("    FROM SNMPHost\n");
  printf("    WHERE _oid>=1000000000\n");
  printf("  RAISERROR('\''SNMPHost OID=%%d'\'', 0, 1, @OID)\n");
  printf("  INSERT INTO SNMPHost\n");
  printf("  (\n");
  printf("    _ParentCID,\n");
  printf("    _ParentID,\n");
  printf("    _oid,\n");
  printf("    _IPHostName,\n");
  printf("    _Vendor,\n");
  printf("    _SNMPsysdescr,\n");
  printf("    _SNMPsyslocation,\n");
  printf("    _SNMPsyscontact,\n");
  printf("    _SNMPsysObjectID,\n");
  printf("    _SNMPAgent\n");
  printf("  )\n");
  printf("  VALUES\n");
  printf("  (\n");
  printf("    '\''%s'\'',\n", cid);
  printf("    @id,\n");
  printf("    @OID,\n");
  printf("    @IPHostName,\n");
  printf("    @Vendor,\n");
  printf("    @SNMPsysdescr,\n");
  printf("    @SNMPsyslocation,\n");
  printf("    @SNMPsyscontact,\n");
  printf("    @SNMPsysObjectID,\n");
  printf("    @SNMPAgent\n");
  printf("  )\n");
  printf("  IF @@ROWCOUNT <> 1\n");
  printf("  BEGIN\n");
  printf("    ROLLBACK TRANSACTION %s\n", proc_name);
  printf("    RETURN -30000\n");
  printf("  END\n");
  printf("\n");
}
{
  print $0;
}
' $1 > $1.tmp
mv -f $1.tmp $1

