-- $Header:   //ARCHIVE/Archive_NLS/db/sql/_GetMNO2Flag.sqv   1.0   Jun 01 2001 11:53:38   Marc  $

USE Object
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = '_GetMNO2Flag' AND type = 'P')
  DROP PROCEDURE _GetMNO2Flag
GO
PRINT 'Creating procedure _GetMNO2Flag...'
GO

-- $Archive:   //ARCHIVE/Archive_NLS/db/sql/_GetMNO2Flag.sqv  $
-- $Author:   Marc  $
-- $Date:   Jun 01 2001 11:53:38  $
-- $Revision:   1.0  $
CREATE PROCEDURE _GetMNO2Flag
  @cid		ClassID,
  @id		ObjID,
  @field	NVARCHAR(100),
  @value	BIT OUTPUT
AS

  -- Accepted values for @field:
  -- Problem         0x00000001
  -- Change          0x00000002
  -- Automation      0x00000004

  -- standard transaction logic
  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN _GetMNO2Flag
  ELSE
    SAVE TRAN _GetMNO2Flag

  -- make sure the input params are correct
  IF @field IS NULL
  BEGIN
    RAISERROR('The parameter field cannot be NULL.', 11, 1)
    ROLLBACK TRAN _GetMNO2Flag
    RETURN
  END

  -- find the value of the flag
  CREATE TABLE #tempval ( flag INT )
  DECLARE @id_str NVARCHAR(10), @cname NVARCHAR(24), @table sysname, @flag_consolidated BIT, @flagval INT
  SET @id_str = CAST(@id AS NVARCHAR(10))
  SELECT @cname = cname, @flag_consolidated = flag_consolidated FROM obj_class WHERE cid = @cid
  IF @flag_consolidated = 1
    SET @table = @cname + '_C'
  ELSE
    SET @table = @cname + '_A'
  EXEC("INSERT INTO #tempval SELECT _flags FROM " + @table + " WHERE id = " + @id_str)
  SELECT @flagval = flag FROM #tempval

  -- Lookup the value from the enumeration
  DECLARE @bitval INT
  SELECT @bitval = value
  FROM enumeration e JOIN enum_value ev ON e.eid = ev.eid
  WHERE e.name = 'MNO2FlagValues' AND ev.name = @field
  IF @@ROWCOUNT = 0
  BEGIN
    RAISERROR('_GetMNO2Flag: Getting of field %s is not supported.', 11, 1, @field)
    ROLLBACK TRAN _GetMNO2Flag
    RETURN
  END

  -- compute the new value
  IF (@flagval & @bitval) <> 0 SET @value = 1 ELSE SET @value = 0

  -- finish up transaction
  IF @tcount = 0
    COMMIT TRAN _GetMNO2Flag

GO

PRINT 'Done.'

