-- $Header:   //ARCHIVE/Archive_NLS/db/sql/_RegisterSMSInts.sqv   1.0   Jun 07 2001 10:21:48   Marc  $

USE Object
GO

PRINT 'Creating procedure _RegisterSMSInts...'

IF EXISTS (SELECT * FROM sysobjects WHERE name = '_RegisterSMSInts' AND type = 'P')
  DROP PROCEDURE _RegisterSMSInts
GO

-- $Archive:   //ARCHIVE/Archive_NLS/db/sql/_RegisterSMSInts.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 07 2001 10:21:48  $
-- $Author:   Marc  $
CREATE PROCEDURE _RegisterSMSInts
  @cid	ClassID,
  @id	ObjID,
  @suppressOffs TINYINT=0
AS 
  RAISERROR('_RegisterSMSInts: %s, %d', 0, 1, @cid, @id)

  -- Standard TRANSACTION logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN _RegisterSMSInts
  ELSE
    SAVE TRAN _RegisterSMSInts

  IF @cid = 'LOB'
    SELECT @cid = dst_cid, @id = dst_id FROM link
    WHERE link_type = 'LOBL' AND src_cid = @cid AND src_id = @id AND deleted = 0

  DECLARE @cmd NVARCHAR(255)
  EXEC master..xp_asisprintf @cmd OUTPUT, 'sh SendSMSIntervalRegistrations.ksh -c%s -i%lu -Aregister', @cid, @id
  IF @suppressOffs = 1
    SET @cmd = @cmd + ' -O'
  PRINT @cmd
  CREATE TABLE #output (line NVARCHAR(4000))
  INSERT INTO #output
  EXEC master..xp_cmdshell @cmd
  SELECT * FROM #output
 
  -- Finish up TRANSACTION
  IF @tcount = 0
    COMMIT TRAN _RegisterSMSInts

GO

PRINT 'Done.'