-- $Header:   //ARCHIVE/Archive_NLS/db/sql/_UnregisterSMSInts.sqv   1.0   Jun 07 2001 10:21:58   Marc  $

USE Object
GO

PRINT 'Creating procedure _UnregisterSMSInts...'

IF EXISTS (SELECT * FROM sysobjects WHERE name = '_UnregisterSMSInts' AND type = 'P')
  DROP PROCEDURE _UnregisterSMSInts
GO

-- $Archive:   //ARCHIVE/Archive_NLS/db/sql/_UnregisterSMSInts.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 07 2001 10:21:58  $
-- $Author:   Marc  $
CREATE PROCEDURE _UnregisterSMSInts
  @cid	ClassID,
  @id	ObjID
AS 
  RAISERROR('_UnregisterSMSInts: %s, %d', 0, 1, @cid, @id)

  -- Standard TRANSACTION logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN _UnregisterSMSInts
  ELSE
    SAVE TRAN _UnregisterSMSInts

  IF @cid = 'LOB'
    SELECT @cid = dst_cid, @id = dst_id FROM link
    WHERE link_type = 'LOBL' AND src_cid = @cid AND src_id = @id AND deleted = 0

  DECLARE @cmd NVARCHAR(255)
  EXEC master..xp_asisprintf @cmd OUTPUT, 'sh SendSMSIntervalRegistrations.ksh -c%s -i%lu -Aunregister', @cid, @id
  PRINT @cmd
  CREATE TABLE #output (line NVARCHAR(4000))
  INSERT INTO #output
  EXEC master..xp_cmdshell @cmd
  SELECT * FROM #output
 
  -- Finish up TRANSACTION
  IF @tcount = 0
    COMMIT TRAN _UnregisterSMSInts

GO

PRINT 'Done.'