-- $Header:   //ARCHIVE/Archive_NLS/db/sql/asisp_renameobj.sqv   1.1   Jun 11 2001 10:18:44   Marc  $

USE Object
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_renameobj' AND type = 'P')
  DROP PROCEDURE asisp_renameobj
GO

-- $Header:   //ARCHIVE/Archive_NLS/db/sql/asisp_renameobj.sqv   1.1   Jun 11 2001 10:18:44   Marc  $
-- This procedure is used to rename an object
CREATE PROCEDURE asisp_renameobj
  @cid	ClassID,
  @id	ObjID,
  @name	ObjName
AS

  -- standard transaction logic
  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN asisp_renameobj
  ELSE
    SAVE TRAN asisp_renameobj

  DECLARE @id_str NVARCHAR(10), @cname sysname, @table sysname
  SELECT @cname = cname FROM obj_class WHERE cid = @cid
  SET @table = @cname + '_C'
  IF @cname IS NULL OR NOT EXISTS (SELECT * FROM sysobjects WHERE name = @table AND (type = 'V' OR type = 'U'))
  BEGIN
    RAISERROR('asisp_renameobj: ERROR: %s is not a valid object class', 11, 1, @cid)
    ROLLBACK TRAN asisp_renameobj
    RETURN -30000
  END

  -- rename object
  SET @id_str = CAST(@id AS NVARCHAR(10))
  EXEC("
    UPDATE " + @table + "
    SET name = N'" + @name + "'
    WHERE id = " + @id_str + "
  ")

  -- finish transaction
  IF @tcount = 0
    COMMIT TRAN asisp_renameobj

GO
