--
-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/asisp_selectRMFProfile.sqv   1.1   Jun 11 2001 13:31:14   DAVID  $
--

USE Object
GO
SET NOCOUNT ON
GO

-------------------------------------------------------------------------------
PRINT 'Adding columns to RMFProfileDef...'
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE id=OBJECT_ID('RMFProfileDef') AND name=N'param_04')
  ALTER TABLE RMFProfileDef ADD param_04 NVARCHAR(50) NULL
GO
IF NOT EXISTS (SELECT * FROM syscolumns WHERE id=OBJECT_ID('RMFProfileDef') AND name=N'param_05')
  ALTER TABLE RMFProfileDef ADD param_05 NVARCHAR(50) NULL
GO
IF NOT EXISTS (SELECT * FROM syscolumns WHERE id=OBJECT_ID('RMFProfileDef') AND name=N'interval')
  ALTER TABLE RMFProfileDef ADD interval INT
GO
IF NOT EXISTS (SELECT * FROM syscolumns WHERE id=OBJECT_ID('RMFProfileDef') AND name=N'alignment')
  ALTER TABLE RMFProfileDef ADD alignment INT
GO

UPDATE RMFProfileDef SET interval=100 WHERE interval IS NULL
GO
UPDATE RMFProfileDef SET alignment=0 WHERE alignment IS NULL
GO

-------------------------------------------------------------------------------
-- asisp_selectRMFProfile
PRINT 'Creating PROCEDURE asisp_selectRMFProfile...'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='asisp_selectRMFProfile')
  DROP PROCEDURE asisp_selectRMFProfile
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/asisp_selectRMFProfile.sqv  $
-- $Revision:   1.1  $
-- $Date:   Jun 11 2001 13:31:14  $
-- $Author:   DAVID  $
CREATE PROCEDURE asisp_selectRMFProfile
  @cid         ClassID,
  @id          ObjID,
  @formatted   TINYINT=1
AS
  RAISERROR('asisp_selectRMFProfile: cid=%s, id=%d...', 0, 1, @cid, @id)

  -- Standard transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount > 0
    SAVE TRANSACTION asisp_selectRMFProfile
  ELSE
    BEGIN TRANSACTION asisp_selectRMFProfile

  CREATE TABLE #uploadOSs
  (
    cid               ClassID,
    id                ObjID,
    name              ObjName      NULL DEFAULT NULL,
    _UploadUserID     NVARCHAR(16)  NULL DEFAULT NULL,
    _UploadPassword   NVARCHAR(16)  NULL DEFAULT NULL,
    svc_host          NVARCHAR(30)  NULL,
    svc_name          NVARCHAR(30)  NULL
  )
  INSERT #uploadOSs(cid, id, name, _UploadUserID, _UploadPassword, svc_host, svc_name) 
    EXEC asisp_uploadGetOSInfo @cid, @id

  -- Replace the OS name with the SMFID field since this is what is actually required
  UPDATE u SET name = os._SMFID
  FROM #uploadOSs AS u JOIN OS_V AS os ON u.cid = 'OS' AND u.id = os.id
  WHERE os._SMFID IS NOT NULL

  IF @formatted = 0
    SELECT *
      FROM #uploadOSs AS o 
        LEFT OUTER JOIN RMFProfileObjReln AS r ON o.cid = r.obj_cid AND o.id = r.obj_id
        JOIN RMFProfileDef AS d ON d.id = ISNULL(r.id,1)
        JOIN RMFProfile AS p ON d.id = p.id
        JOIN obj_class AS oc ON o.cid=oc.cid
      WHERE p.enabled = 1 AND ISNULL(r.enabled,1) = 1 AND d.enabled = 1
  ELSE
  BEGIN
    SELECT 'DATA_ROW|'+RTRIM(o.cid)+'|'+RTRIM(oc.cno)+'|'+CONVERT(NVARCHAR(255),o.id)+'|'+RTRIM(o.name)+'|' + RTRIM(metric_basename) + '|' +
        CASE param_01 WHEN '%name%' THEN RTRIM(o.name)
                      ELSE RTRIM(param_01)
                      END + '|' +
        CASE param_02 WHEN '%name%' THEN RTRIM(o.name)
                      ELSE RTRIM(param_02)
                      END + '|' +
        CASE param_03 WHEN '%name%' THEN RTRIM(o.name)
                      ELSE RTRIM(param_03)
                      END + '|' +
        CASE param_04 WHEN '%name%' THEN RTRIM(o.name)
                      ELSE RTRIM(param_04)
                      END + '|' +
        CASE param_05 WHEN '%name%' THEN RTRIM(o.name)
                      ELSE RTRIM(param_05)
                      END + '|' +
        RTRIM(metric_comparison) + '|' + CONVERT(NVARCHAR(255),metric_value) + '|' + RTRIM(metric_id) + '|' + RTRIM(metric_category) + '|' + RTRIM(metric_description) + '|' +
        CONVERT(NVARCHAR(255),interval) + '|' + CONVERT(NVARCHAR(255),alignment) + '|'
      FROM #uploadOSs AS o 
        LEFT OUTER JOIN RMFProfileObjReln AS r ON o.cid = r.obj_cid AND o.id = r.obj_id
        JOIN RMFProfileDef AS d ON d.id = ISNULL(r.id,1)
        JOIN RMFProfile AS p ON d.id = p.id
        JOIN obj_class AS oc ON o.cid=oc.cid
      WHERE p.enabled = 1 AND ISNULL(r.enabled,1) = 1 AND d.enabled = 1
  END

  -- Finish up transaction
  IF @tcount = 0
    COMMIT TRANSACTION asisp_selectRMFProfile
GO

---------------------------------------------------------------------------------
PRINT 'Done.'
GO

