-- Fix defect 77398

-- modify ca7_jobs table

USE 
Object
GO
-----------------------------------------------------------------------------------------------
-- save the data into a temp table
SELECT * INTO temp_ca7_jobs FROM ca7_jobs
GO
-- drop old table
DROP TABLE ca7_jobs
GO
-- Create new table
PRINT 'Recreating table ca7_jobs'
EXEC ('CREATE TABLE ca7_jobs
  (
    obj_id 		ObjID DEFAULT 0,
    name 		ObjName PRIMARY KEY (name, cycle_name, sched_id, btcy_id, bulk_load),
    cycle_name 		ObjName DEFAULT NULL,
    sched_id		TINYINT DEFAULT 0,
    flag_keyjob 	TINYINT DEFAULT 0,
    year_start 		INT DEFAULT 2000,
    day_start 		SMALLINT DEFAULT 0,
    time_start 		NVARCHAR(20) NULL,
    time_duration 	NVARCHAR(20) NULL,
    year_stop 		INT DEFAULT 2000,
    day_stop 		SMALLINT DEFAULT 0,
    time_stop 		NVARCHAR(20) NULL,
    start_date_time 	DATETIME DEFAULT ''19000101'',
    end_date_time 	DATETIME DEFAULT ''19000101'',
    duration 		int DEFAULT 0,
    btcy_id 		ObjID DEFAULT 0,
    bulk_load		INT DEFAULT 1
  )'
)
GO

-- transfer data from temp table into ca7_jobs table
INSERT ca7_jobs SELECT * FROM temp_ca7_jobs 
GO
-- drop temp table
DROP TABLE temp_ca7_jobs
GO
