-- $Header:   //ARCHIVE/Archive_NLS/db/sql/d77152.sqv   1.0   Jun 07 2001 14:28:44   Marc  $

USE Object
GO

-- View CICS_V
PRINT 'Creating view CICS_V'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'CICS_V' AND type = 'V')
  DROP VIEW CICS_V
GO

-- $Archive:   //ARCHIVE/Archive_NLS/db/sql/d77152.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 07 2001 14:28:44  $
-- $Author:   Marc  $
CREATE VIEW CICS_V AS
  SELECT o.id, name, revision, nchild, description, o.ctime, mtime, userid, deleted,
    _APPLID,
    _JOBNAME,
    _MASTYPE,
    _RELEASE_NO,
    _RegisteredFiles,
    _ShutdownDelay,
    _StartupDelay,
    _SystemName,
    _UnavailableFiles,
    _UnregisteredFiles,
    _ConsoleTrapStatus,
    _DISCOVERY_IND,
    _MONITOR_LEVEL,
    _SCHED_PACK,
    _SysplexResource,
    _LogonToLocalPM,
    _OmegamonLogin='ATRC/CICS/OMGL-' + convert(NVARCHAR(9), _OmegamonLoginID),
    _OmegamonLoginID,
    _AlertState='GENC/STCR-1/ALRS-' + convert(NVARCHAR(9), _AlertStateID) + '/T/Desc',
    _AlertStateID,
    _ChildEventMatrix='ACPX/CICS-'+convert(NVARCHAR(9),a.id)+'/PRMX-' + convert(NVARCHAR(9), _ChildEventMatrixID) + '/T',
    _ChildEventMatrixID,
    _ChildEvents='ATRC/CICS-'+convert(NVARCHAR(9),a.id)+'/CHEV',
    _CurrentState='CICS/STCR-1/STTP-' + convert(NVARCHAR(9), _CurrentStateID) + '/T/State',
    _CurrentStateID,
    _DesiredState='CICS/STCR-1/STTP-' + convert(NVARCHAR(9), _DesiredStateID) + '/T/State',
    _DesiredStateID,
    _ExceptionMatrix='AEPX/CICS-'+convert(NVARCHAR(9),a.id)+'/PRMX-' + convert(NVARCHAR(9), _ExceptionMatrixID) + '/T',
    _ExceptionMatrixID,
    _ExceptionTypes='ATRC/CICS-'+convert(NVARCHAR(9),a.id)+'/EXTP',
    _Exceptions='ATRC/CICS-'+convert(NVARCHAR(9),a.id)+'/EXCP',
    _MessageDescriptions='ATRC/CICS-'+convert(NVARCHAR(9),a.id)+'/MSGD',
    _Messages='ATRC/CICS-'+convert(NVARCHAR(9),a.id)+'/MESG',
    _Notes='ATRC/CICS-'+convert(NVARCHAR(9),a.id)+'/NOTE',
    _Priority='GENC/STCR-1/OPRI-' + convert(NVARCHAR(9), _PriorityID) + '/T/Priority',
    _PriorityID,
    _Desc,
    _HasOwnershipNote,
    _flags
FROM
  CICS_C AS o JOIN CICS_A AS a ON a.id = o.id
GO


-- asisp_joinedviewCICS
PRINT 'Creating procedure asisp_joinedviewCICS'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_joinedviewCICS' AND type = 'P')
  DROP PROCEDURE asisp_joinedviewCICS
GO

-- $Archive:   //ARCHIVE/Archive_NLS/db/sql/d77152.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 07 2001 14:28:44  $
-- $Author:   Marc  $
-- Joined-view procedure for CICS(cid=CICS)
-- This procedure provides a standard way to join the class view with another
-- set of tables/views.
create procedure asisp_joinedviewCICS
  @initial_columns  NVARCHAR(255), -- Comma-separated list of columns from joined tables to be selected
                                  -- These are selected before the view's columns.
                                  -- Can be null or empty string.
  @joined_tables    NVARCHAR(255), -- Comma-separated list of tables to join to view.
                                  -- The view name should *not* be in this list.
                                  -- Can be null or empty string.
  @where_clause     NVARCHAR(255)  -- Where clause for the join.  The view name has a shorthand of 'v' and.
                                  -- and reference to view attributes must be prefixed with 'v._'.
as
  -- raiserror('asisp_joinedviewCICS', 0, 1)
  -- raiserror('  @initial_columns=''%s''', 0, 1, @initial_columns)
  -- raiserror('  @joined_tables=''%s''', 0, 1, @joined_tables)
  -- raiserror('  @where_clause=''%s''', 0, 1, @where_clause)
  -- Make sure that the initial column list, if specified, ends with a comma
  if @initial_columns <> null and substring(@initial_columns, len(@initial_columns), 1) <> ','
    select @initial_columns = @initial_columns + ','
  -- Make sure that the additional table list, if specified, starts with a comma
  if @joined_tables <> null and substring(@joined_tables, 1, 1) <> ','
    select @joined_tables = ',' + @joined_tables
  exec('select ' + 
       @initial_columns + 
       'v.id, v.name, v.revision, v.nchild, v.description, v.ctime, v.mtime, v.userid, v.deleted,' +
       'v._APPLID,' +
       'v._JOBNAME,' +
       'v._MASTYPE,' +
       'v._RELEASE_NO,' +
       'v._RegisteredFiles,' +
       'v._ShutdownDelay,' +
       'v._StartupDelay,' +
       'v._SystemName,' +
       'v._UnavailableFiles,' +
       'v._UnregisteredFiles,' +
       'v._ConsoleTrapStatus,' +
       'v._DISCOVERY_IND,' +
       'v._MONITOR_LEVEL,' +
       'v._SCHED_PACK,' +
       'v._SysplexResource,' +
       'v._LogonToLocalPM,' +
       'v._OmegamonLogin,' +
       'v._OmegamonLoginID,' +
       'v._AlertState,' +
       'v._AlertStateID,' +
       'v._ChildEventMatrix,' +
       'v._ChildEventMatrixID,' +
       'v._ChildEvents,' +
       'v._CurrentState,' +
       'v._CurrentStateID,' +
       'v._DesiredState,' +
       'v._DesiredStateID,' +
       'v._ExceptionMatrix,' +
       'v._ExceptionMatrixID,' +
       'v._ExceptionTypes,' +
       'v._Exceptions,' +
       'v._MessageDescriptions,' +
       'v._Messages,' +
       'v._Notes,' +
       'v._Priority,' +
       'v._PriorityID,' +
       'v._Desc,' +
       'v._HasOwnershipNote,' +
       'v._flags' +
       ' from CICS_V v' + @joined_tables +
       ' where ' + @where_clause
      )
GO


-- asisp_viewCICS
PRINT 'Creating procedure asisp_viewCICS'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_viewCICS' AND type = 'P')
  DROP PROCEDURE asisp_viewCICS
GO

-- $Archive:   //ARCHIVE/Archive_NLS/db/sql/d77152.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 07 2001 14:28:44  $
-- $Author:   Marc  $
-- View procedure for CICS(cid=CICS)
-- The standard class columns are selected, followed by the CICS-specific ones
create procedure asisp_viewCICS
  @id ObjID
as
  -- raiserror('asisp_viewCICS @id=%d', 0, 1, @id)
  select
    -- standard class columns
    v.id, v.name, v.revision, v.nchild, v.description, v.ctime, v.mtime, v.userid, v.deleted,
    v._APPLID,
    v._JOBNAME,
    v._MASTYPE,
    v._RELEASE_NO,
    v._RegisteredFiles,
    v._ShutdownDelay,
    v._StartupDelay,
    v._SystemName,
    v._UnavailableFiles,
    v._UnregisteredFiles,
    v._ConsoleTrapStatus,
    v._DISCOVERY_IND,
    v._MONITOR_LEVEL,
    v._SCHED_PACK,
    v._SysplexResource,
    v._LogonToLocalPM,
    v._OmegamonLogin,
    v._OmegamonLoginID,
    v._AlertState,
    v._AlertStateID,
    v._ChildEventMatrix,
    v._ChildEventMatrixID,
    v._ChildEvents,
    v._CurrentState,
    v._CurrentStateID,
    v._DesiredState,
    v._DesiredStateID,
    v._ExceptionMatrix,
    v._ExceptionMatrixID,
    v._ExceptionTypes,
    v._Exceptions,
    v._MessageDescriptions,
    v._Messages,
    v._Notes,
    v._Priority,
    v._PriorityID,
    v._Desc,
    v._HasOwnershipNote,
    v._flags
  from CICS_V v
  where id = @id
GO


PRINT 'Done.'
GO
