-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/sp_sendrulepulse.sqv   1.0   Jun 20 2001 14:40:42   BRENT  $
--
-- sp_sendrulepulse.sql
--
-- Module Description
--   Defines the sp_sendrulepulse stored procedure

USE master
GO


---------------------------------------------------------------------------------------------------
-- sp_sendrulepulse
PRINT 'Creating procedure sp_sendrulepulse'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'sp_sendrulepulse' AND type = 'P')
  DROP PROCEDURE sp_sendrulepulse
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/sp_sendrulepulse.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 20 2001 14:40:42  $
-- $Author:   BRENT  $
-- Causes the new system time to be asserted to the rulebase, followed by a 'run' command
CREATE PROCEDURE sp_sendrulepulse
  @RuleBaseName NVARCHAR(255) = NULL
AS
  IF @RuleBaseName IS NOT NULL
  BEGIN
    -- send the pulse to specified rule bases
    EXEC sp_setrulebasetime @RuleBaseName
    EXEC sp_sendrulecmd @RuleBaseName, '(run 1000)'
  END
  ELSE
  BEGIN
    -- send the pulse to all rule bases
    DECLARE sp_sendrulepulse_cc INSENSITIVE CURSOR FOR
      SELECT Name FROM ASIRuleSvc..RuleBase
    OPEN sp_sendrulepulse_cc
    FETCH NEXT FROM sp_sendrulepulse_cc INTO @RuleBaseName
    WHILE @@FETCH_STATUS <> -1
    BEGIN
      EXEC sp_setrulebasetime @RuleBaseName
      EXEC sp_sendrulecmd @RuleBaseName, '(run 1000)'
      FETCH NEXT FROM sp_sendrulepulse_cc INTO @RuleBaseName
    END
    DEALLOCATE sp_sendrulepulse_cc
  END
GO
