-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/sp_setrulebasetime.sqv   1.0   Jun 20 2001 14:40:44   BRENT  $
--
-- sp_setrulebasetime.sql
--
-- Module Description
--   Defines the sp_setrulebasetime stored procedure

USE master
GO


---------------------------------------------------------------------------------------------------
-- sp_setrulebasetime
PRINT 'Creating procedure sp_setrulebasetime'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'sp_setrulebasetime' AND type = 'P')
  DROP PROCEDURE sp_setrulebasetime
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/sp_setrulebasetime.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jun 20 2001 14:40:44  $
-- $Author:   BRENT  $
-- Sends a rule command to a specified rulebase setting the current time to either a specified
-- value or the current system time.
CREATE PROCEDURE sp_setrulebasetime
  @RuleBaseName  NVARCHAR(255),
  @now           SMALLDATETIME=NULL -- If NULL then the current system time is set
AS
  DECLARE @sql NVARCHAR(255)
  IF @now IS NULL
   SET @now=CURRENT_TIMESTAMP

  -- Convert the date to an integers
  DECLARE @nDateTime INT
  EXEC @nDateTime=sp_date2int @now
  SELECT @sql = 'sp_sendrulecmd '''+@RuleBaseName+''', ''(send [SystemTime] SetTime ' + 
                CONVERT(NVARCHAR(12),@nDateTime) +
                ' "' + CONVERT(NVARCHAR(32), @now, 113) + '"' +
                ')'''
  EXEC(@sql)
  RAISERROR('%s', 0, 1, @sql)
GO
